/* Zdrojový soubor modulu modul
 *
 * Autor: David Martinek, 2023
 *
 * 2023-08-10-13.59
 */

// Natažení rozhraní pro správnou typovou kontrolu.
#include "modul.h"

// Natažení rozhraní systémových modulů.
// #include <stdio.h> // Není zde potřeba, protože se natahuje v modul.h.
#include <time.h>

/** Vrátí aktuální rok zjištěný funkcemi time a localtime.
 * Neveřejná funkce je vidět jen uvnitř modulu.
 * Konvencí je začínat názvy skrytých funkcí podtržítkem.
 */
int _aktualniRok(void)
{
  time_t sec=time(NULL);
  struct tm* tedka=localtime(&sec);
  return tedka->tm_year + 1900;
}

// Definice (vytvoření) a inicializace globální konstantní proměnné.
const int KONSTANTNI_PROMENNA = 666;

// Implementace veřejných funkcí
// Hlavičky musí odpovídat prototypům v hlavičkovém souboru, jinak dojde
// k chybám během překladu.
// Tip: V IDE pro přejmenování používej vždy nástroje pro refaktorizaci.
Tosoba vyrobOsobu(const char *jmeno, int rokNarozeni)
{
  int rok = _aktualniRok();
  Tosoba o = {.jmeno = jmeno};
  if (rok < rokNarozeni)
    o.vek = 0;
  else
    o.vek = rok - rokNarozeni;
  return o;
}

void tiskniOsobu(FILE * f, Tosoba o)
{
  if (f == NULL) return;
  fprintf(f, "  => jmeno: %s\n", o.jmeno);
  fprintf(f, "  => vek: %d\n", o.vek);
}
